/*
 * $QNXLicenseC:
 * Copyright 2008, QNX Software Systems. 
 * 
 * Licensed under the Apache License, Version 2.0 (the "License"). You 
 * may not reproduce, modify or distribute this software except in 
 * compliance with the License. You may obtain a copy of the License 
 * at: http://www.apache.org/licenses/LICENSE-2.0 
 * 
 * Unless required by applicable law or agreed to in writing, software 
 * distributed under the License is distributed on an "AS IS" basis, 
 * WITHOUT WARRANTIES OF ANY KIND, either express or implied.
 *
 * This file may contain contributions from others, either as 
 * contributors under the License or as licensors under other terms.  
 * Please review this entire file for other proprietary rights or license 
 * notices, as well as the QNX Development Suite License Guide at 
 * http://licensing.qnx.com/license-guide/ for other information.
 * $
 */





#include "startup.h"

paddr32_t	lapic_paddr = NULL_PADDR32;
void		*lapic_vaddr;

void
apic_set_paddr(paddr_t p) {
	lapic_paddr = p;
}


void
apic_set_vaddr(void) {
	if(lapic_paddr == NULL_PADDR32) {
		// discovering the number of CPU's tells us where the local APIC is
		if(acpi_smp_num_cpu() == 0) {
			imps_smp_num_cpu();
		}	
	}
	if(lapic_paddr != NULL_PADDR32) {
		lapic_vaddr = (void *)x86_map(~0L, lapic_paddr, __PAGESIZE, X86_PTE_PRESENT | X86_PTE_WRITE);
	}
}

__SRCVERSION("apic_paddr.c $Rev: 1 $");
