/*
 * $QNXLicenseC:
 * Copyright 2007, 2008, QNX Software Systems. 
 * 
 * Licensed under the Apache License, Version 2.0 (the "License"). You 
 * may not reproduce, modify or distribute this software except in 
 * compliance with the License. You may obtain a copy of the License 
 * at: http://www.apache.org/licenses/LICENSE-2.0 
 * 
 * Unless required by applicable law or agreed to in writing, software 
 * distributed under the License is distributed on an "AS IS" basis, 
 * WITHOUT WARRANTIES OF ANY KIND, either express or implied.
 *
 * This file may contain contributions from others, either as 
 * contributors under the License or as licensors under other terms.  
 * Please review this entire file for other proprietary rights or license 
 * notices, as well as the QNX Development Suite License Guide at 
 * http://licensing.qnx.com/license-guide/ for other information.
 * $
 */


/*
;
; This is a kernel hardware callout.
; It may be called from within an interrupt handler.
; This code MUST be position independant.
;
*/

#include "callout.ah"

/*
;
; void display_char(struct syspage_entry *sysp, char c)
;
; Display debug messages from kdebug or the kernel.
;
*/
CALLOUT_START(display_char_vga, 0, 0)

#define BCOLS		0x44a
#define BROW		0x451
#define BCOL		0x450
#define SCREEN		0xb0000

    pushal   
    movb      0x28(%esp),%cl		// character to output
    movl      0x24(%esp),%ebx		// syspage
    xorl      %edx,%edx
    movl      SYSPAGE_REALADDR(%ebx),%ebx
    movb      BROW(%ebx),%dh
    movb      BCOL(%ebx),%dl
    movb      %cl,%al
    cmpb      $0x0d,%al				// carriage return
    jne       X$1
    xorb      %dl,%dl
    jmp       X$5
X$1:
    cmpb      $0x0a,%al				// line feed
    jne       X$3
X$2:
    xorb      %dl,%dl
    incb      %dh
    cmpb      $0x18,%dh
    jle       X$5
    decb      %dh
    pushl     %esi
    pushl     %ecx
    leal      SCREEN(%ebx),%edi
    movzbl    BCOLS(%ebx),%esi
    shll      $0x00000001,%esi
    addl      %edi,%esi
    xorl      %eax,%eax
    movb      BCOLS(%ebx),%al
    movb      $25,%ah
    mulb      %ah
    movl      %eax,%ecx
    pushl     %esi
    pushl     %ecx
    repe; movsw 
    movw      $0x0720,%ax
    movb      BCOLS(%ebx),%cl
    repe; stosw 
    leal      SCREEN+0x8000(%ebx),%edi
    popl      %ecx
    popl      %esi
    addl      $0x8000,%esi
    repe; movsw 
    movw      $0x0720,%ax
    movb      BCOLS(%ebx),%cl
    repe; stosw 
    popl      %ecx
    popl      %esi
    jmp       X$5
X$3:
    cmpb      $0x0c,%al				// home
    jne       X$4
    xorl      %edx,%edx
    jmp       X$5
X$4:
    pushl     %eax
    pushl     %ecx
    xorl      %eax,%eax
    movb      BCOLS(%ebx),%al
    mulb      %dh
    shll      $0x00000001,%eax
    xorl      %ecx,%ecx
    movb      %dl,%cl
    shll      $0x00000001,%ecx
    addl      %ecx,%eax
    leal      SCREEN(%ebx),%edi
    addl      %eax,%edi
    popl      %ecx
    popl      %eax
    movb      $0x07,%ah
    movw      %ax,(%edi)
    movw      %ax,0x8000(%edi)
    incb      %dl
    cmpb      BCOLS(%ebx),%dl
    jge       X$2
X$5:
    movb      %dh,BROW(%ebx)
    movb      %dl,BCOL(%ebx)
	xor       %eax,%eax
    movb      BCOLS(%ebx),%al
    mulb      %dh
	xor		  %ecx,%ecx
	movb	  BCOL(%ebx),%cl
	add		  %eax,%ecx
//	shrl	  $1,%ecx
    movw      $0x3d4,%dx
	mov		  $14,%al
    outb      %al,%dx
    inc       %dx
    movb      %ch,%al
    outb      %al,%dx
	dec		  %dx
	mov		  $15,%al
    outb      %al,%dx
    inc       %dx
    movb      %cl,%al
    outb      %al,%dx
    popal    
    ret       
CALLOUT_END(display_char_vga)
	
/*
;
; int poll_key( volatile struct syspage_entry *)
;
; return a key value, or -1 if no key is available (for kdebug use)
;
*/
CALLOUT_START(poll_key_pckbd, 0, 0)
	xorl	  %eax,%eax
	inb  	  $0x64,%al				// key code available?
    testb     $0x01,%al
    je        X$6
    inb       $0x60,%al
    xorb      $0x80,%al
    andl      $0x00000080,%eax		// ignore key-up codes
    je        X$6
    orl       $0x00000100,%eax		// indicate non-ascii character
    ret       
X$6:
    movl      $-1,%eax
    ret       
CALLOUT_END(poll_key_pckbd)
	
/*
;
; int break_detect( volatile struct syspage_entry *)
;
; return a 1 if a break condition is detected, 0 otherwise
;
*/
CALLOUT_START(break_detect_pckbd, 0, 0)
		xorl	%eax,%eax
		ret
CALLOUT_END(break_detect_pckbd)
