/*
 * $QNXLicenseC:
 * Copyright 2007, 2008, QNX Software Systems. 
 * 
 * Licensed under the Apache License, Version 2.0 (the "License"). You 
 * may not reproduce, modify or distribute this software except in 
 * compliance with the License. You may obtain a copy of the License 
 * at: http://www.apache.org/licenses/LICENSE-2.0 
 * 
 * Unless required by applicable law or agreed to in writing, software 
 * distributed under the License is distributed on an "AS IS" basis, 
 * WITHOUT WARRANTIES OF ANY KIND, either express or implied.
 *
 * This file may contain contributions from others, either as 
 * contributors under the License or as licensors under other terms.  
 * Please review this entire file for other proprietary rights or license 
 * notices, as well as the QNX Development Suite License Guide at 
 * http://licensing.qnx.com/license-guide/ for other information.
 * $
 */


/*
;
; This is a kernel hardware callout.
; It may be called from within an interrupt handler.
; This code MUST be position independant.
;
*/

#include	"callout.ah"

/*
;
;
; void timer_load(volatile struct syspage_entry *, struct qtime_entry *qtp)
;
*/
CALLOUT_START(timer_load_8254, 0, 0)
	movl	  8(%esp),%eax
	movl	  QT_TIMER_LOAD(%eax),%edx
	cmp		  $0xffff,%edx
	jbe		  1f
	mov		  $0xffff,%edx
	movl	  %edx,QT_TIMER_LOAD(%eax)
1:	
	pushfl
    cli       
    movb      $0x34,%al
    outb      %al,$0x43
    movb      %dl,%al
    outb      %al,$0x40
    movb      %dh,%al
    outb      %al,$0x40
    popfl    
    ret       
CALLOUT_END(timer_load_8254)

/*
;
;
; int timer_reload(volatile struct syspage_entry *, struct qtime_entry *qtp)
;
*/
CALLOUT_START(timer_reload_8254, 0, 0)
		// don't need to do anything with this chip
		movl	$1,%eax		// indicate that it is a timer interrupt
		ret
CALLOUT_END(timer_reload_8254)

/*
;
;
; unsigned timer_value(volatile struct syspage_entry *, struct qtime_entry *qtp)
;	syspage_entry in EAX, qtime_entry in EDX
;
*/
CALLOUT_START(timer_value_8254, 0, 0)
    movl      QT_TIMER_LOAD(%edx),%edx
    xorl      %eax,%eax
    pushfl   
    cli       
    movb      $0x00,%al		// latch the counter
    outb      %al,$0x43
    inb       $0x40,%al
    movb      %al,%ah
    inb       $0x40,%al
    popfl    
    xchgb     %ah,%al
    subl      %eax,%edx
    movl      %edx,%eax
    ret       
CALLOUT_END(timer_value_8254)
