/*
 * $QNXLicenseC:
 * Copyright 2008, QNX Software Systems. 
 * 
 * Licensed under the Apache License, Version 2.0 (the "License"). You 
 * may not reproduce, modify or distribute this software except in 
 * compliance with the License. You may obtain a copy of the License 
 * at: http://www.apache.org/licenses/LICENSE-2.0 
 * 
 * Unless required by applicable law or agreed to in writing, software 
 * distributed under the License is distributed on an "AS IS" basis, 
 * WITHOUT WARRANTIES OF ANY KIND, either express or implied.
 *
 * This file may contain contributions from others, either as 
 * contributors under the License or as licensors under other terms.  
 * Please review this entire file for other proprietary rights or license 
 * notices, as well as the QNX Development Suite License Guide at 
 * http://licensing.qnx.com/license-guide/ for other information.
 * $
 */





#include "startup.h"

void exec386(unsigned msw, uintptr_t eip, uintptr_t kern_syspage, unsigned cpu);
	
struct linear_descriptor_entry {
	uint16_t  limit;
	uint32_t  base;
} __attribute__((packed));
	
static void
get_base_limit(struct linear_descriptor_entry *ldesc, struct x86_seg_descriptor_entry *sdesc) {
	ldesc->limit = sdesc->limit;
	ldesc->base  = sdesc->base_lo + ((uint32_t)sdesc->base_hi << 16) + ((uint32_t)sdesc->base_xhi << 24);
}

void
cpu_startnext(uintptr_t eip, unsigned cpu) {
	struct x86_seg_descriptor_entry *gdt = TOPTR(gdt_paddr);
	struct linear_descriptor_entry 	desc;
	unsigned						bits;
	
	get_base_limit(&desc, &gdt[1]);
	lgdt(&desc);

	get_base_limit(&desc, &gdt[2]);
	lidt(&desc);

	bits = X86_MSW_PE_BIT | X86_MSW_WP_BIT;
	if(shdr->flags1 & STARTUP_HDR_FLAGS1_VIRTUAL) {
		x86_load_pgdir(cpu);
		bits |= X86_MSW_PG_BIT;
	}
	exec386(bits, eip, (uintptr_t)lsp.system_private.p->kern_syspageptr, cpu);
} 

__SRCVERSION("cpu_startnext.c $Rev: 1 $");
