/*
 * $QNXLicenseC:
 * Copyright 2008, QNX Software Systems. 
 * 
 * Licensed under the Apache License, Version 2.0 (the "License"). You 
 * may not reproduce, modify or distribute this software except in 
 * compliance with the License. You may obtain a copy of the License 
 * at: http://www.apache.org/licenses/LICENSE-2.0 
 * 
 * Unless required by applicable law or agreed to in writing, software 
 * distributed under the License is distributed on an "AS IS" basis, 
 * WITHOUT WARRANTIES OF ANY KIND, either express or implied.
 *
 * This file may contain contributions from others, either as 
 * contributors under the License or as licensors under other terms.  
 * Please review this entire file for other proprietary rights or license 
 * notices, as well as the QNX Development Suite License Guide at 
 * http://licensing.qnx.com/license-guide/ for other information.
 * $
 */




.text

#define		STACK_SIZE	3100

#define	SAVE_SIZE		(0x5*4)
#define	SAVE_EIP_OFF	0x00
#define	SAVE_CS_OFF		0x04
#define	SAVE_EFL_OFF	0x08
#define	SAVE_ESP_OFF	0x10
#define	SAVE_SS_OFF		0x14

	.extern		_main
	.extern		boot_regs

	.globl		_cstart_
_cstart_:
	.globl	_start
_start:
	movl	%eax,boot_regs //save EAX temporarily
    movw	%ds,%ax
    movw    %ax,%es
    movw    %ax,%ss
    movl    %esp,stack_top-SAVE_SIZE+SAVE_ESP_OFF
    movl    $stack_top-SAVE_SIZE,%esp
    movl	boot_regs,%eax
    pushal
    movl	%esp,boot_regs
    cld       

	// Clear the nested task flag to make sure we are at a clean state...
    pushfl    
    pop		%eax
    and     $0xffff00ff,%eax	// clear TF, IF, DF, OF, NT, IOPL=0
    pushl   %eax
    popfl					// clear NT bit BEFORE the IRET (so the IRET will work)
    or 		$0x1000,%eax	// THEN set iopl==1 in flags we will pop to force
    push    %eax			// privity change
    pushl   %cs
    pushl   $1f
    iret
1:

    call      _main
1:
    jmp       1b
	
	.align		8			// Align the stack to 8 bytes... (size of signature)
	.globl		boot_args
boot_args:
	.ascii	  "ddpvbskr"	// signature for mkifs
	.space	  STACK_SIZE
stack_top:
