/*
 * $QNXLicenseC:
 * Copyright 2007, 2008, QNX Software Systems. 
 * 
 * Licensed under the Apache License, Version 2.0 (the "License"). You 
 * may not reproduce, modify or distribute this software except in 
 * compliance with the License. You may obtain a copy of the License 
 * at: http://www.apache.org/licenses/LICENSE-2.0 
 * 
 * Unless required by applicable law or agreed to in writing, software 
 * distributed under the License is distributed on an "AS IS" basis, 
 * WITHOUT WARRANTIES OF ANY KIND, either express or implied.
 *
 * This file may contain contributions from others, either as 
 * contributors under the License or as licensors under other terms.  
 * Please review this entire file for other proprietary rights or license 
 * notices, as well as the QNX Development Suite License Guide at 
 * http://licensing.qnx.com/license-guide/ for other information.
 * $
 */


#include "startup.h"

//
// Convert a set of ELF permission bits to X86 specific ones and
// map in the specified memory region with the given permissions.
//
void
elf_map(uintptr_t vaddr, paddr32_t paddr, size_t size, int flags) {
	int	pf;

	pf = X86_PTE_PRESENT;
	if(flags & PF_W) pf |= X86_PTE_WRITE;
	x86_map(vaddr, paddr, size, pf);
}

__SRCVERSION("elf_map.c $Rev: 1 $");
