/*
 * $QNXLicenseC:
 * Copyright 2008, QNX Software Systems. 
 * 
 * Licensed under the Apache License, Version 2.0 (the "License"). You 
 * may not reproduce, modify or distribute this software except in 
 * compliance with the License. You may obtain a copy of the License 
 * at: http://www.apache.org/licenses/LICENSE-2.0 
 * 
 * Unless required by applicable law or agreed to in writing, software 
 * distributed under the License is distributed on an "AS IS" basis, 
 * WITHOUT WARRANTIES OF ANY KIND, either express or implied.
 *
 * This file may contain contributions from others, either as 
 * contributors under the License or as licensors under other terms.  
 * Please review this entire file for other proprietary rights or license 
 * notices, as well as the QNX Development Suite License Guide at 
 * http://licensing.qnx.com/license-guide/ for other information.
 * $
 */





#include "startup.h"


unsigned
find_top_cpu_intr() {
	struct intrinfo_entry		*intr;
	unsigned					max_intr;
	unsigned					curr_intr;
	unsigned					num;

	// Find the highest hardware interrupt vector so far.

	max_intr = 0;
	intr = lsp.intrinfo.p;
	num = lsp.intrinfo.size / sizeof(*intr);
	do {
		curr_intr = intr->cpu_intr_base;
		if(intr->cpu_intr_stride != 0) {
			curr_intr += intr->cpu_intr_stride * (intr->num_vectors-1);
		}
		if(curr_intr > max_intr) max_intr = curr_intr;
		++intr;
	} while(--num != 0);
	return max_intr;
}

__SRCVERSION("find_top_intr.c $Rev: 1 $");
