/*
 * $QNXLicenseC:
 * Copyright 2008, QNX Software Systems. 
 * 
 * Licensed under the Apache License, Version 2.0 (the "License"). You 
 * may not reproduce, modify or distribute this software except in 
 * compliance with the License. You may obtain a copy of the License 
 * at: http://www.apache.org/licenses/LICENSE-2.0 
 * 
 * Unless required by applicable law or agreed to in writing, software 
 * distributed under the License is distributed on an "AS IS" basis, 
 * WITHOUT WARRANTIES OF ANY KIND, either express or implied.
 *
 * This file may contain contributions from others, either as 
 * contributors under the License or as licensors under other terms.  
 * Please review this entire file for other proprietary rights or license 
 * notices, as well as the QNX Development Suite License Guide at 
 * http://licensing.qnx.com/license-guide/ for other information.
 * $
 */




.text

.extern		cpu_features
.extern		cpu_features_set

	.globl		x86_cputype
x86_cputype:
    pushl     %ebx			// save registers
    pushl     %ecx
    pushl     %edx

//
// Test for 386:	386 will not permit the AC bit in flags to be set.
//
    movl      $386,%eax
    pushl     %ecx
    pushl     %ebx
    pushfl   
    popl      %ebx
    pushl     %ebx
    movl      %ebx,%ecx
    xorl      $0x00040000,%ebx
    pushl     %ebx
    popfl    
    pushfl   
    popl      %ebx
    cmpl      %ecx,%ebx
    je        X$1

//
// Test for 486:	486 will not permit the ID in flags to be set.
//
    movl      $486,%eax
    movl      %ecx,%ebx
    xorl      $0x00200000,%ebx
    pushl     %ebx
    popfl    
    pushfl   
    popl      %ebx
    cmpl      %ecx,%ebx
    je        X$1

//
// 586 and forward have an instruction to get machine type.
// The 'major' number is stored in ah.
// Return the major number *5 + 86
//
    movl      $0x00000001,%eax
    cpuid     
    andb      $0x0f,%ah
	cmpb	  $4,%ah
	jne		  1f
	andl	  $0x11,%edx // Don't trust feature flags on late model 486's
1:
    movl      %edx,cpu_features
    movb      $0x01,cpu_features_set
    movb      %ah,%al
    xorb      %ah,%ah
    imulw     $0x0064,%ax
    addw      $0x0056,%ax
X$1:
    popfl    
    popl      %ebx
    popl      %ecx
    popl      %edx
    popl      %ecx
    popl      %ebx
    ret       
