/*
 * $QNXLicenseC:
 * Copyright 2008, QNX Software Systems. 
 * 
 * Licensed under the Apache License, Version 2.0 (the "License"). You 
 * may not reproduce, modify or distribute this software except in 
 * compliance with the License. You may obtain a copy of the License 
 * at: http://www.apache.org/licenses/LICENSE-2.0 
 * 
 * Unless required by applicable law or agreed to in writing, software 
 * distributed under the License is distributed on an "AS IS" basis, 
 * WITHOUT WARRANTIES OF ANY KIND, either express or implied.
 *
 * This file may contain contributions from others, either as 
 * contributors under the License or as licensors under other terms.  
 * Please review this entire file for other proprietary rights or license 
 * notices, as well as the QNX Development Suite License Guide at 
 * http://licensing.qnx.com/license-guide/ for other information.
 * $
 */






#define LAPIC_ID	0x0020
#define LAPIC_VER	0x0030
#define LAPIC_TPR	0x0080
#define LAPIC_APR	0x0090
#define LAPIC_PPR	0x00a0
#define LAPIC_EOI	0x00b0
#define LAPIC_LDR	0x00d0
#define LAPIC_DFR	0x00e0
#define LAPIC_SVR	0x00f0
#define LAPIC_SPIV	0x00f0
#define LAPIC_ESR	0x0280
#define LAPIC_ICRL	0x0300
#define LAPIC_ICRH	0x0310
#define LAPIC_LTR	0x0320
#define LAPIC_LTMR	0x0330
#define LAPIC_LPCR	0x0340
#define LAPIC_LL0R	0x0350
#define LAPIC_LL1R	0x0360
#define LAPIC_LER	0x0370
#define LAPIC_ICR	0x0380
#define LAPIC_CCR	0x0390
#define LAPIC_TDCR	0x03e0

#define ICR_INIT	0x00004500L
#define ICR_STARTUP	0x00004600L

#define LVR_VERSION_SHIFT			0
#define LVR_VERSION_MASK			0xff
#define LVR_MAX_LVT_SHIFT			16
#define LVR_MAX_LVT_MASK			(0xff << 16)

#define LVT_VECTOR_SHIFT			0
#define LVT_VECTOR_MASK				0xff
#define LVT_DELIVERY_MODE_SHIFT		8
#define LVT_DELIVERY_MODE_MASK		(0x7 << 8)
#define LVT_DELIVERY_MODE_FIXED		(0x0 << 8)
#define LVT_DELIVERY_MODE_SMI		(0x2 << 8)
#define LVT_DELIVERY_MODE_NMI		(0x4 << 8)
#define LVT_DELIVERY_MODE_ExtINT	(0x7 << 8)
#define LVT_DELIVERY_MODE_INIT		(0x5 << 8)
#define LVT_DELIVERY_STATUS			(1<<12)
#define LVT_POLARITY_LOW			(1<<13)
#define LVT_REMOTE_IRR				(1<<14)
#define LVT_TRIGGER_MODE_LEVEL		(1<<15)
#define LVT_MASKED					(1<<16)
#define LVT_TIMER_MODE_PERIODIC		(1<<17)

#define SVR_VECTOR_SHIFT			0
#define SVR_VECTOR_MASK				0xff
#define SVR_APIC_ENABLED			(1<<8)
#define SVR_FOCUS_DISABLED			(1<<9)

#define apic_read(reg)			(*(uint32_t *)(lapic_paddr+(reg)))
#define apic_write(reg, val)	(*(uint32_t *)(lapic_paddr+(reg)) = (val));

#define apic_id() 	((apic_read(LAPIC_ID) >> 24) & 0xf)

/* __SRCVERSION("lapic.h $Rev: 1 $"); */
