/*
 * $QNXLicenseC:
 * Copyright 2008, QNX Software Systems. 
 * 
 * Licensed under the Apache License, Version 2.0 (the "License"). You 
 * may not reproduce, modify or distribute this software except in 
 * compliance with the License. You may obtain a copy of the License 
 * at: http://www.apache.org/licenses/LICENSE-2.0 
 * 
 * Unless required by applicable law or agreed to in writing, software 
 * distributed under the License is distributed on an "AS IS" basis, 
 * WITHOUT WARRANTIES OF ANY KIND, either express or implied.
 *
 * This file may contain contributions from others, either as 
 * contributors under the License or as licensors under other terms.  
 * Please review this entire file for other proprietary rights or license 
 * notices, as well as the QNX Development Suite License Guide at 
 * http://licensing.qnx.com/license-guide/ for other information.
 * $
 */





#include "startup.h"


void
set_desc32(struct x86_seg_descriptor_entry *sd, int flags1, int flags2, uintptr_t linear, uintptr_t len) {

	if(flags2 & X86_G_BIT) {
		if (len & 0x0fff) len += 0x1000;
		len /= 0x1000;
	}

	sd->base_lo = linear & 0xffff;
	sd->base_hi = (linear >> 16) & 0xff;
	sd->base_xhi = (linear >> 24) & 0xff;

	sd->flags = flags1;
	sd->limit = (len - 1) & 0xffff;
	sd->limflags = (((len - 1) >> 16) & 0xf) | flags2;
}

__SRCVERSION("set_desc.c $Rev: 1 $");
