/*
 * $QNXLicenseC:
 * Copyright 2007, 2008, QNX Software Systems. 
 * 
 * Licensed under the Apache License, Version 2.0 (the "License"). You 
 * may not reproduce, modify or distribute this software except in 
 * compliance with the License. You may obtain a copy of the License 
 * at: http://www.apache.org/licenses/LICENSE-2.0 
 * 
 * Unless required by applicable law or agreed to in writing, software 
 * distributed under the License is distributed on an "AS IS" basis, 
 * WITHOUT WARRANTIES OF ANY KIND, either express or implied.
 *
 * This file may contain contributions from others, either as 
 * contributors under the License or as licensors under other terms.  
 * Please review this entire file for other proprietary rights or license 
 * notices, as well as the QNX Development Suite License Guide at 
 * http://licensing.qnx.com/license-guide/ for other information.
 * $
 */



#include "startup.h"

	
unsigned long
x86_cpuid(int v, void *p) {
	unsigned long ret;

	__asm__ __volatile__(
		"pushfl;"		
		"popl	%%ebx;"	
		"movl	%%ebx, %%ecx;"
		"xorl	$0x00200000,%%ecx;"
		"pushl	%%ecx;"
		"popfl;"				
		"pushfl;"
		"popl	%%ebx;"
		"cmpl	%%ebx, %%ecx;"
		"je		1f;"
		"xorl	%%eax, %%eax;"
		"jmp	2f;"
		"1:;"
		"cpuid;"
		"orl	%%esi, %%esi;"
		"jz		2f;"					
		"movl	%%ebx, 0(%%esi);"
		"movl	%%edx, 4(%%esi);"
		"movl	%%ecx, 8(%%esi);"
		"2:"				
		: "=a" (ret)
		:"a" (v), "S" (p)
		: "ebx", "ecx", "edx", "memory");

	return ret;
}

__SRCVERSION("x86_cpuid.c $Rev: 1 $");
